;; m4/theme.jl

;; based on minimal by Garcia Galego <rgarcia@eurielec.etsit.upm.es>
;; hacked up a bit by Jacob Berkman <jacob@helixcode.com>
;; hacked again by Dave Berton <db@null.net>

(let* (

  (font (get-font "-misc-fixed-medium-r-semicondensed-*-*-90-*-*-c-*-iso8859-1"))

(title-width
  (lambda (w)
  (let
      ((w-width (car (window-dimensions w))))
      ( + (max 0 (text-width (window-name w) font)) 12 )  ) ))

  (update-text-width
     (lambda (w)
      (if (eq (window-get w 'current-frame-style) 'm4)
	  (rebuild-frame w))))

  (font-colors (list (get-color "black")    (get-color "black")))
  (colors      (list (get-color "darkgrey") (get-color "lightgrey")))

  (pre-colors  (list (get-color "darkgrey") (get-color "white")))
  (post-colors (list (get-color "darkgrey") (get-color "black")))
  (mid-colors  (list (get-color "darkgrey") (get-color "white")))

(frame
 `(
   ;; Bar
   ((background . ,colors)
    (foreground . ,font-colors)
    (font . ,font)
    (text . ,window-name)
    (top-edge . -9 )
    (height . 10)
    (right-edge . 12)
    (width . ,(lambda (w) ( + (title-width w) 12 )))
    (x-justify . center)
    (y-justify . center)
    (class . title))

   ;; Separator
   ((background . ,mid-colors)
    (top-edge . , -10)
    (right-edge . 11)
    (height . 12)
    (width . 1)
    (class menu-button))

   ;; Window borders
   ((background . ,pre-colors)
    (top-edge . -10)
    (right-edge . -1)
    (left-edge . -1)
    (height . 1)
    (class . top-border))

   ((background . ,pre-colors)
    (top-edge . -9)
    (bottom-edge . 0)
    (left-edge . -1)
    (width . 1)
    (class . left-border))

   ((background . ,post-colors)
    (top-edge . -9)
    (bottom-edge . 0)
    (right-edge . -1)
    (width . 1)
    (class . right-border))

   ((background . ,post-colors)
    (height . 1)
    (bottom-edge . -1 )
    (right-edge . -1)
    (left-edge . -1)
    (class . bottom-border))

   ;; Other frame borders...
   ((background . ,post-colors)
    (top-edge . 1)
    (right-edge . 0)
    (height . 1)
    (width . ,(lambda (w) (+ (title-width w) 25))))

   ((background . ,pre-colors)
    (top-edge . -10)
    (right-edge . ,(lambda (w) (+ (title-width w) 24)))
    (width . 1)
    (height . 11))

   ;; Button
   ((background . ,colors)
    (top-edge . -9)
    (right-edge . 0)
    (height . 10)
    (width . 11)
    (class . menu-button))))


(shaped-frame
 `(
   ;; Bar
   ((background . ,colors)
    (foreground . ,font-colors)
    (font . ,font)
    (text . ,window-name)
    (top-edge . -9 )
    (height . 10)
    (right-edge . 12)
    (width . ,(lambda (w) ( + (title-width w) 12 )))
    (x-justify . center)
    (y-justify . center)
    (class . title))

   ;; Separator
   ((background . ,mid-colors)
    (top-edge . , -10)
    (right-edge . 11)
    (height . 12)
    (width . 1)
    (class menu-button))

   ;; Other frame borders...
   ((background . ,post-colors)
    (top-edge . -9)
    (height . 12)
    (right-edge . -1)
    (width . 1)
    (class . right-border))

   ((background . ,pre-colors)
    (top-edge . -10)
    (right-edge . -1)
    (height . 1)
    (width . ,(lambda (w) (+ (title-width w) 25))))

   ((background . ,post-colors)
    (top-edge . 1)
    (right-edge . 0)
    (height . 1)
    (width . ,(lambda (w) (+ (title-width w) 25))))

   ((background . ,pre-colors)
    (top-edge . -10)
    (right-edge . ,(lambda (w) (+ (title-width w) 24)))
    (width . 1)
    (height . 11))

   ;; Button
   ((background . ,colors)
    (top-edge . -9)
    (right-edge . 0)
    (height . 10)
    (width . 11)
    (class . menu-button))))

)

(add-frame-style 'm4
		 (lambda (w type)
		   (cond ((eq type 'shaped)
			  shaped-frame)
			 ((eq type 'transient)
			  nil-frame)
			 ((eq type 'shaped-transient)
			  nil-frame)
			 ((eq type 'unframed)
			  nil-frame)
			 (t
			  frame))))

(call-after-property-changed 'WM_NAME update-text-width))
